
#include "Wire.h"


#define CMD 0x7E
int BMA400_ADDR = 0x14;
int Powermode, ID,val;
int INT_INPUT = 2;


void setup() {
  //  Wire.setModule(0);
  Wire.begin();
  Serial.begin(9600);
  pinMode(INT_INPUT, INPUT);

    //Software Reset
  Wire.beginTransmission(BMA400_ADDR);
  Wire.write(CMD);
  Wire.write(0xB6);
  Wire.endTransmission();
  delay(100); //delay 100ms

  Wire.beginTransmission(BMA400_ADDR);
  Wire.write(0);
  Wire.endTransmission();
  delay(1);
  Wire.requestFrom(BMA400_ADDR, 1);
  ID = Wire.read();
  Serial.print("ID = ");
  Serial.println(ID);

  // Normal mode 
  Wire.beginTransmission(BMA400_ADDR);
  Wire.write(0x19);
  Wire.write(0x02);
  Wire.endTransmission();
  delay(10);

  // INT1 is mapped
  Wire.beginTransmission(BMA400_ADDR);
  Wire.write(0x21);
  Wire.write(0x04);
  Wire.endTransmission();
  // INT CONFIG
  Wire.beginTransmission(BMA400_ADDR);
  Wire.write(0x20);
  Wire.write(0x00);
  Wire.endTransmission();
  // INT1 pint output level - High-active
  Wire.beginTransmission(BMA400_ADDR);
  Wire.write(0x24);
  Wire.write(0x02);
  Wire.endTransmission();

  // GEN1_ACT_Z,X,Y, data src active
  Wire.beginTransmission(BMA400_ADDR);
  Wire.write(0x3F);
  Wire.write(0xFA);
  Wire.endTransmission();

  // GEN1_COMB_SEL - AND selected
  Wire.beginTransmission(BMA400_ADDR);
  Wire.write(0x40);
  Wire.write(0x01);
  Wire.endTransmission();

  // GEN1 threshold
  Wire.beginTransmission(BMA400_ADDR);
  Wire.write(0x41);
  Wire.write(0x10);
  Wire.endTransmission();

  // GEN! INT duration
  Wire.beginTransmission(BMA400_ADDR);
  Wire.write(0x42);
  Wire.write(0x00);
  Wire.endTransmission();
  
  // GEN! INT duration
  Wire.beginTransmission(BMA400_ADDR);
  Wire.write(0x43);
  Wire.write(0x0F);
  Wire.endTransmission();

  // GEN1 interrupt enable
  Wire.beginTransmission(BMA400_ADDR);
  Wire.write(0x1F);
  Wire.write(0x04);
  Wire.endTransmission();

  
  attachInterrupt(digitalPinToInterrupt(INT_INPUT), interrupt, RISING);
}

void loop() {
}

void interrupt()
{
  Serial.println("Interrupt Check");
}
